    .model small
    .data
    .code
     org 100h
           JMP START
    HIGHEST__NUMBER       EQU 47
    TIMES__PICKED         EQU 6
    TOTAL__NUMBERS        EQU TIMES__PICKED * 40
FILE:
    FILE_NUMBERS_USED     DB 1   dup(0)
    FILE_TIMES_PICKED     DB HIGHEST__NUMBER dup(0)
    NUMBERS               DB TOTAL__NUMBERS dup(0)
    FILE_LENGTH           DW $ - FILE 
    FILE_HANDLE           DW 1 
    FILE_NAME             DB "LOTTO.NUM",0
    TEMP_6                DB TIMES__PICKED DUP(0)
    TEMP_6_L_H            DB TIMES__PICKED DUP(0)
    TEMP_BYTE             DB 1
    TEMP_WORD             DW 1
    TEMP_LOOP             DW 1
    TEMP_LOOP2            DW 1
    TEMP_LINE             DB 1
    TEMP_COLUMN           DB 1
    TEMP_LOCATION         DB 1 
    TEMP_LENGTH           DW 1 
    TEMP_MSG_ADDR         DW 1
    TEMP_MSG2_ADDR        DW 1
    TEMP_6_INDEX          DW 1 
    IN_HEX                DB 1 DUP(0)  ;**** KEEP STAR LINES TOGETHER ****
    IN_NUMBERS            DB 2 DUP(0)  ;*
    NUMBERS_START         DB 3 DUP(0)  ;*** START OF DATA FOR IN_NUMBERS *
    ASCII_STRING          DB 7
    IN_BUFFER             DB 2 DUP(0)
    BUFFER_START          DB 20 DUP(20)    ;START OF DATA FOR IN_BUFFER
    READ_FILE_FLAG        DB 1 DUP(0)
    DIVIDE_1              DW 1 
    DIVIDE_2              DB 1
    DIVIDE_3              DW 1
    WEEKS                 DB 1 
    RETURN_BACKGROUND     DW 1 
    RETURN_FOREGROUND     DW 1 
    MAIN_MENU             DB " MAIN MENU SCREEN $"
    MAIN_MSG1             DB " 1 INITIALIZE DATA BASE $"
    MAIN_MSG2             DB " 2 ADD NUMBERS TO DATA BASE $"
    MAIN_MSG3             DB " 3 PICK NUMBERS WITH DATA BASE $"
    MAIN_MSG4             DB " 4 PICK NUMBER WITHOUT DATA BASE $"
    MAIN_MSG5             DB " 5 PICK LEAST PICKED NUMBERS $"
    MAIN_MSG6             DB " 6 VIEW DATA BASE NUMBERS $"
    MAIN_MSG7             DB " 7 VIEW TIMES PICKED PER NUMBER $"
    MAIN_MSG8             DB " 8 TIMES PER COLUMN $ "
    MAIN_MSG9             DB " 9 QUIT LOTTERY $"
    MAIN_COMMAND          DB " ENTER NUMBER 1-9 $"
    CLEAR_SCREEN          DB 1Bh,5Bh,32h,4Ah,24h
    BOLD_ON               DB 1Bh,5Bh,31h,6Dh,24h
    UNDERSCORE_ON         DB 1Bh,5Bh,34h,6Dh,24h
    BLINK_ON              DB 1Bh,5Bh,35h,6Dh,24h
    ATTRIBUTES_OFF        DB 1Bh,5Bh,30h,6Dh,24h
    REVERSE_ON            DB 1Bh,5Bh,37h,6Dh,24h
    ERASE_TO_END_OF_LINE  DB 1Bh,5Bh,4Bh,24h
    CYAN_FOREGROUND       DB 1Bh,5Bh,33h,36h,6Dh,24h
    CYAN_BACKGROUND       DB 1Bh,5Bh,34h,36h,6Dh,24h
    RED_FOREGROUND        DB 1Bh,5Bh,33h,31h,6Dh,24h
    RED_BACKGROUND        DB 1Bh,5Bh,34h,31h,6Dh,24h
    BLACK_FOREGROUND      DB 1Bh,5Bh,33h,30h,6Dh,24h
    BLACK_BACKGROUND      DB 1Bh,5Bh,34h,30h,6Dh,24h
    GREEN_BACKGROUND      DB 1Bh,5Bh,34h,32h,6Dh,24h
    GREEN_FOREGROUND      DB 1Bh,5Bh,33h,32h,6Dh,24h
    BLUE_FOREGROUND       DB 1Bh,5Bh,33h,34h,6Dh,24h
    BLUE_BACKGROUND       DB 1Bh,5Bh,34h,34h,6Dh,24h
    YELLOW_FOREGROUND     DB 1Bh,5Bh,33h,33h,6Dh,24h
    YELLOW_BACKGROUND     DB 1Bh,5Bh,34h,33h,6Dh,24h
    MAGENTA_FOREGROUND    DB 1Bh,5Bh,33h,35h,6Dh,24h
    MAGENTA_BACKGROUND    DB 1Bh,5Bh,34h,35h,6Dh,24h
    WHITE_FOREGROUND      DB 1Bh,5Bh,33h,37h,6Dh,24h
    WHITE_BACKGROUND      DB 1Bh,5Bh,34h,37h,6Dh,24h
    INITIALIZE_MSG1    DB " CAUTION CAUTION CAUTION $"
    INITIALIZE_MSG2    DB " INITIALIZE CLEARS DATABASE CONTINUE $"
    WITH_MSG1          DB " PICK NUMBERS WITH DATA BASE SCREEN $"
    WITH_MSG2          DB " HOW MANY WEEKS OF DATA DO YOU WISH TO USE ? $"
    WITH_MSG3          DB " DO YOU WISH TO ADD WEIGHT TO DATA BASE NUMBERS $"
    WITH_MSG4          DB " ENTER A NUMBER BETWEEN 1 - 20 $"
    WITH_MSG5          DB " USING    DRAWINGS OF DATA $"
    WITHOUT_MSG1       DB " PICK NUMBERS WITHOUT DATA BASE NUMBERS $"
    LEAST_MSG1         DB " LEAST PICKED NUMBERS USING DATA BASE $"
    DATA_ADD1          DB " ADD DATA SCREEN $"
    DATA_ADD2          DB " PLEASE ENTER NUMBERS IN LOW/HIGH FORMAT $"
    DATA_ADD3          DB " THIS IS YOUR        NUMBER      $"
    DATA_ADD5          DB " THAT NUMBER NOT EXCEPTABLE - try again $"
    DATA_ADD6          DB " ADD ANOTHER DRAWING TO DATA BASE $"
    DATA_ADD7          DB " ENTER A LETTER TO RETURN TO MAIN MENU"
		       DB " WITHOUT SAVING DATA $"
    DATA_ADD8          DB " ENTER ZERO TO TO CORRECT DATA $"
    GET_Y_N_MSG1       DB " Y/N ? $"
    ADD_WITH2          DB " THIS IS YOUR        NUMBER    PICKED    TIMES $"
    ADD_WITH3          DB " ENTER NUMBERS IN LOW/HIGH FORMAT $"
    ADD_WITH4          DB " DO YOU WANT TO ADD MORE DATA $"
    REVIEW_MSG1        DB " REVIEW DATA NUMBERS SCREEN $"
    REVIEW_MSG2        DB "                       $"
    TIMES_PICKED_MSG1  DB " TIMES PICKED SCREEN $"
    TIMES_PICKED_MSG2  DB "   /   $"
    TIMES_PER_MSG1     DB " TIMES PICKED PER COLUMN $"
    TIMES_PER1         DB " TIMES PICKED / PER COLUMN $"
    TIMES_PER2         DB "   /   $"
    CHOICE             DW OFFSET FIRST
                       DW OFFSET SECOND
                       DW OFFSET THIRD
                       DW OFFSET FOURTH
                       DW OFFSET FIFTH
                       DW OFFSET SIXTH
    FIRST              DB "FIRST$"
    SECOND             DB "SECOND$"
    THIRD              DB "THIRD$"
    FOURTH             DB "FOURTH$"
    FIFTH              DB "FIFTH$"
    SIXTH              DB "SIXTH$" 
    NG_OPEN            DB 10,13,13,"FILE FAILED TO OPEN ERROR CODE $"
    NG_READ            DB 10,13,13,"BAD READ - ERROR NUMBER $"
    NG_READ2           DB 10,13,13,"WRONG BYTE READ - $"
    NG_WRITE           DB 10,13,13," WRITE NO GOOD - ERROR $"
    NG_WRITE2          DB 10,13,13," WRITE BYTES DONT MATCH FILE LENGTH$"
    CALC_ERROR         DB ' NUMBER MUST BE BELOW 20 TRY AGAIN $'
    WEEKS_TO_USE       DB ' HOW MANY WEEKS OF DATA DO YOU WISH TO USE ? $'
    WANT_TO_CONTINUE   DB " DO YOU WISH TO CONTINUE $"
    LEAST_NUMBERS      DB HIGHEST__NUMBER DUP(0)
    TOTAL              DB " TOTAL $"
    TOTAL_TIMES_PICKED DB 0
    TOTAL_PER_COLUMN   DB 0

START PROC NEAR
	   MOV  AL, 178        ;set up rANDom number generator
	   OUT  43H, AL
	   MOV  AL, 0
	   OUT  42H, AL
	   MOV  AL, 255
	   OUT  42H, AL

PRT_MAIN_SCREEN PROC NEAR
	   MOV  AH, 09H                     ;SCREEN BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET MAIN_MENU        ;print main menu bar
	   MOV  TEMP_MSG_ADDR, DX
	   MOV  DX, 0
	   MOV  TEMP_MSG2_ADDR, DX          ;BLANK 2ED LINE
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX       ;PRINT  FOREGROUND COLOR
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX       ;PRINT  BACKGROUND COLOR
	   CALL PRINT_HEADER
	   MOV  AH, 02H
	   MOV  dH, 3
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG1        ;prINT s menu options
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 5
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG2
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 7
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG3
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 9
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG4
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 11
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG5
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 13
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG6
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 15
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG7
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 17
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG8
	   MOV  AH, 09H
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 19
	   MOV  Dl, 20
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET MAIN_MSG9
	   MOV  AH, 09H
	   INT  21H
ENTER_CHOICE:
	   MOV   DX, OFFSET MAIN_COMMAND            ;prINT s selection request
	   CALL PRINT_COMMAND
	   CALL GET_NUMBERS                ;get numBer of selection
	   MOV  AL, IN_HEX
	   CMP  AL, 01                      ;compares selection to possiBle
	   JE   CHOICE_1                     ;CHOICEs AND BrancHes to selection.
	   CMP  AL, 02
	   JE   CHOICE_2
	   CMP  AL, 03
	   JE   CHOICE_3
	   CMP  AL, 04
	   JE   CHOICE_4
	   CMP  AL, 05
	   JE   CHOICE_5
	   CMP  AL, 06
	   JE   CHOICE_6
	   CMP  AL, 7
	   JE   CHOICE_7
	   CMP  AL, 8
	   JE   CHOICE_8
	   CMP  AL, 09
	   JE   Done
	   JMP  enTer_CHOICE
CHOICE_1:  CALL INITIALIZE
	   JMP  PRT_MAIN_SCREEN
CHOICE_2:  CALL ADD_DATA
	   JMP  PRT_MAIN_SCREEN
CHOICE_3:  CALL piCk_wiTH
	   JMP  PRT_MAIN_SCREEN
CHOICE_4:  CALL piCk_wiTHOUT
	   JMP  PRT_MAIN_SCREEN
CHOICE_5:  CALL PICK_LEAST
	   JMP  PRT_MAIN_SCREEN
CHOICE_6:  CALL REVIEW
	   JMP  PRT_MAIN_SCREEN
CHOICE_7:  CALL TIMES_PICKED
	   JMP  PRT_MAIN_SCREEN
CHOICE_8:  CALL TIMES_PER
	   JMP  PRT_MAIN_SCREEN
DONE:      INT  20H
PRT_MAIN_SCREEN ENDP

PICK_WITH PROC NEAR
	   MOV  AH, 9                       ;SCREEN BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   INT  21H
	   MOV  DX, OFFSET RED_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX       ;PRINT  BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX       ;PRINT  FOREGROUND COLOR
	   MOV  DX, OFFSET WITH_MSG1               ;prINT s PICK WITH menu
	   MOV  TEMP_MSG_ADDR, DX           ;To THe firsT Line
	   MOV  DX, OFFSET WITH_MSG5
	   MOV  TEMP_MSG2_ADDR, DX          ;PRINT S 2ED LINE MENU BAR
	   CALL PRINT_HEADER
	   CALL READ_FILE
	   CALL CALC_DIVISOR               ;DeTermins rANDom numBer rAnge
	   MOV  AH, 02H
	   MOV  DH, 1
	   MOV  DL, 33
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   XOR  AH, AH
	   MOV  AL, WEEKS
	   CALL PRINT_NUMBER                ;PRINTS WEEKS OF DATA BASE NUMBERS
	   MOV  AH, 9                       ;useD To piCk rANDom numBer.
	   MOV  DX, OFFSET WHITE_BACKGROUND        ;seTup for resT of sCreen.
	   MOV  RETURN_BACKGROUND, DX
	   INT  21H
	   MOV  DIVIDE_2, (HIGHEST__NUMBER + TIMES__PICKED)
PW_LOOP4:  MOV  DX, OFFSET WITH_MSG3               ;PRINT S - DO YOU WANT TO ADD WEIGHTS
	   CALL PRINT_COMMAND
	   CALL GET_YES
	   JNE  PW_START
	   MOV  DX, OFFSET WITH_MSG4               ;Ask for ADDeD weigHT for DATA
	   CALL PRINT_COMMAND               ;BASE NUMBER - THE HIGHER THE
	   CALL GET_NUMBERS                ;THe numBer THe more DATA BAse
	   MOV  AL, IN_HEX                  ;numBers HAve A CHAnCe of Being
	   CMP  AL, 20                      ;piCkeD.
	   JA   PW_LOOP4
	   MOV  CL, IN_HEX
	   ADD  DIVIDE_2, CL
PW_START:  MOV  CX, TIMES__PICKED           ;seTs up Loop To geT numBers
PW_LOOP:   PUSH CX
           CALL GET_RANDOM_NUMBER
	   XOR  DX, DX
	   DIV  DIVIDE_2
	   INC  AH
	   CMP  AH, (HIGHEST__NUMBER)       ;DeTermine if rANDom numBer is
	   JA   GET_DB_NUMBER                ;To Be BAse numBer or piCkeD
	   MOV  AL, AH                      ;from DATA BAse
	   JMP  PW_LOOP1
GET_DB_NUMBER:                             
           PUSH AX
	   XOR  AH, AH                      ;MULTIPLIES AL TIMES TIMES_PICKED
	   MOV  TEMP_BYTE, TIMES__PICKED    ;THEN ADD S REMAINDER FROM DIV IDE
	   MUL  TEMP_BYTE                   ;TO GET BASE NUMBER AND PUT IN AL
	   POP  BX
	   MOV  TEMP_BYTE, BH
	   ADD  AL, TEMP_BYTE
	   XOR  BH, BH
	   MOV  BL, FILE_NUMBERS_USED - 1
	   CMP  BX, AX
	   JGE  PW_LOOP5
	   SAR  AX, 1
PW_LOOP5:  MOV  SI, AX
	   MOV  AL, NUMBERS+SI
PW_LOOP1:  MOV  CX, TIMES__PICKED           ;CHECK TO SEE IF NUMBER HAS ALREADY
PW_LOOP2:  MOV  SI,CX                       ;BEEN PICKED
	   DEC  SI
	   CMP  TEMP_6+SI, AL
	   JNE  PW_LOOP3
	   POP  CX
	   JMP  PW_LOOP                     ;IF PICKED GET NEW NUMBER
PW_LOOP3:  LOOP PW_LOOP2
	   POP  CX
	   MOV  SI, CX
	   DEC  SI
	   MOV  TEMP_6+SI, AL               ;THEN SAVES IN TEMP STORAGE
           LOOP PW_LOOP
           CALL LOW_HIGH_SEQUENCE          ;LOW/HIGH STORED IN TEMP_6_L_H
	   MOV  DX, OFFSET WITH_MSG1
	   MOV  TEMP_MSG_ADDR, DX
	   CALL PRINT_NUMBERS              ;PRINTSS NUMBERS
	   CALL TIMES_PER_COLUMN           ;PRINT S TIMES NUMBER WAS PICKED
	   MOV  DX, OFFSET WANT_TO_CONTINUE        ;IN COLUMN CHOOSEN
	   CALL PRINT_COMMAND
	   CALL GET_YES                    ;GET NEW SET OF NUMBERS ?
	   JE   J_PW_START
	   RET
J_PW_START:
	   JMP  PW_START
PICK_WITH  ENDP
PICK_LEAST PROC NEAR
	   MOV  AH, 9                       ;SCREEN BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   INT  21H
	   MOV  DX, OFFSET RED_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX       ;PRINT  BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX       ;PRINT  FOREGROUND COLOR
	   MOV  DX, OFFSET LEAST_MSG1
	   MOV  TEMP_MSG_ADDR, DX
	   MOV  DX, OFFSET WITH_MSG5
	   MOV  TEMP_MSG2_ADDR, DX         ;PRINTS 2ED LINE OF MENU BAR
	   CALL PRINT_HEADER
	   CALL READ_FILE
	   CALL CALC_DIVISOR
	   XOR  AH, AH
	   MOV  AL, WEEKS
	   MOV  BL, TIMES__PICKED
	   MUL  BL
	   MOV  TEMP_WORD, AX
	   MOV  BX, (HIGHEST__NUMBER)
	   ADD  TEMP_WORD, BX
	   DEC  TEMP_WORD
	   MOV  AX, 65535
	   XOR  DX, DX
	   DIV  TEMP_WORD
	   MOV  DIVIDE_1, AX
	   MOV  AH, 02H
	   MOV  DH, 1
	   MOV  DL, 33
	   MOV  BH, 0
	   INT  10H
	   XOR  AH, AH
	   MOV  AL, WEEKS
	   CALL PRINT_NUMBER           ;PRINTS WEEKS OF DATA BASE NUMBERS
	   MOV  AH, 9
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX
	   INT  21H
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX
	   INT  21H
PL_LOOP7:  MOV  AL, 0                       ;START OF PROCEDURE
	   MOV  DI, OFFSET LEAST_NUMBERS     ;ZEROS VARABLE
	   MOV  CX, HIGHEST__NUMBER+1
	   REP STOSB
	   MOV  CX, HIGHEST__NUMBER - TIMES__PICKED
PL_LOOP:   PUSH CX                         ;PICK MOST USED NUMBER HIGHEST
PL_LOOP1:  CALL GET_RANDOM_NUMBER          ;NUMBER -TIMES_PICKED MOV ING FF
	   INC  AX                          ;TO LOCATION THEN MOV E NUMBERS
	   CMP  AX, (HIGHEST__NUMBER)       ;LEFT TO TEMP_6
	   JBE  PL_LOOP3                    ;DeTermine if rANDom numBer is
PL_DB_NUMBER:
	   XOR  BH, BH
	   MOV  BL, (HIGHEST__NUMBER)
	   SUB  AX, BX
	   MOV  BL, TIMES__PICKED
	   DIV  BL
	   PUSH AX
	   XOR  AH, AH                      ;MUL TIPLIES AL TIMES TIMES_PICKED
	   MOV  TEMP_BYTE, TIMES__PICKED    ;THEN ADD S REMAINDER FROM DIV IDE
	   MUL  TEMP_BYTE                   ;TO GET BASE NUMBER AND PUT IN AL
	   POP  BX
	   MOV  TEMP_BYTE, BH
	   ADD  AL, TEMP_BYTE
PL_LOOP2:  MOV  SI, AX
	   MOV  AL, NUMBERS+SI              ;END PL_DB_NUMBER
PL_LOOP3:  XOR  AH, AH
	   MOV  SI, AX
	   MOV  AL, 255
	   CMP  LEAST_NUMBERS+SI, AL
	   JNE  PL_LOOP4
	   POP  CX
	   JMP  PL_LOOP
PL_LOOP4:  MOV  LEAST_NUMBERS+SI, AL       ;MOVE 255 TO LOCATION OF NUMBER
	   POP  CX                          ;REMOV ES FROM NUMBERS TO BE
	   LOOP PL_LOOP                    ;PICKED AS MOST PICKED
	   MOV  TEMP_6_INDEX, 0
	   MOV  CX, HIGHEST__NUMBER
PL_LOOP5:  MOV  SI, CX                      ;MOV E NON-255 NUMBERS TO TEMP_6
	   MOV  AL, 255
	   CMP  LEAST_NUMBERS+SI, AL
	   JE   PL_LOOP6
	   MOV  AX, SI
	   MOV  SI, TEMP_6_INDEX
	   MOV  TEMP_6+SI, AL
	   INC  TEMP_6_INDEX
PL_LOOP6:  LOOP PL_LOOP5
	   CALL LOW_HIGH_SEQUENCE
	   CALL PRINT_NUMBERS
	   CALL TIMES_PER_COLUMN
	   MOV  DX, OFFSET WANT_TO_CONTINUE
	   MOV  TEMP_MSG_ADDR, DX
	   CALL PRINT_COMMAND
	   CALL GET_YES
	   JE   PL_LOOP7_J
	   RET
PL_LOOP7_J:
	   JMP  PL_LOOP7
PICK_LEAST  ENDP

INITIALIZE PROC NEAR
	   MOV  DX, OFFSET RED_BACKGROUND   ;SETUP SCREEN COLORS
	   MOV  RETURN_BACKGROUND, DX
	   MOV  AH, 09H
	   INT  21H
	   MOV  DX, OFFSET WHITE_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, 12
	   MOV  DL, 27
	   MOV  BH, 0
	   INT  10H
	   MOV  DX, OFFSET INITIALIZE_MSG1  ;PRINT S WARNING
	   MOV  AH, 09H
	   INT  21H
	   MOV  DX, OFFSET INITIALIZE_MSG2
	   CALL PRINT_COMMAND
	   CALL GET_YES
	   JE   INITIALIZE_Y                 ;IF YES CONTINUE ELSE RETURN
           RET
INITIALIZE_Y:
	   MOV  AL, 0                       ;ZEROES FILE
	   MOV  DI, FILE
	   MOV  CX, FILE_LENGTH
	   REP  STOSB
           CALL WRITE_FILE                 ;REWRITES FILE WITH EVERYTHING 0
	   RET
INITIALIZE ENDP

ADD_DATA PROC NEAR
	   MOV  AH, 9
	   MOV  DX, OFFSET CYAN_BACKGROUND         ;SETUP SCREEN COLOR FOR MENU BAR
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   INT  21H
	   MOV  DX, OFFSET DATA_ADD1               ;PRINT S ADD  DATA MENU BAR
	   MOV  TEMP_MSG_ADDR, DX
	   MOV  DX, 0
	   MOV  TEMP_MSG2_ADDR, DX
	   MOV  DX, OFFSET GREEN_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX       ;PRINT  BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX       ;PRINT  FOREGROUND COLOR
	   CALL PRINT_HEADER
	   MOV  AH, 02H
	   MOV  DH, 22
	   MOV  DL, 25
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 09
	   MOV  DX, OFFSET DATA_ADD8
	   INT  21H
	   MOV  DX, OFFSET DATA_ADD7
	   MOV  TEMP_MSG_ADDR, DX
	   CALL FIND_CENTER
	   MOV  AH, 02H
	   MOV  DX, TEMP_LENGTH
	   MOV  DH, 23
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 09
	   MOV  DX, OFFSET DATA_ADD7
	   INT  21H
	   MOV  DX, OFFSET BLUE_BACKGROUND         ;SETUP SCREEN FOR REST OF SCREEN
	   MOV  RETURN_BACKGROUND, DX
	   INT  21H
	   MOV  DX, OFFSET CYAN_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX
	   INT  21H
	   CALL READ_FILE
	   CALL GET_TEMP_6
	   CALL MOVE_BLOCK                  ;AFTER 6 NUMBERS ADDED - THE
	   MOV  CX, TIMES__PICKED           ;REST OF THE NUMBERS IN THE DATA
	   MOV  SI, OFFSET TEMP_6           ;BASE ARE MOV ED TO KEEP MOST
	   MOV  DI, OFFSET NUMBERS          ;RECENT NUMBERS IN DATA BASE
	   CLD
	   REP  MOVSB
	   MOV  DX, OFFSET DATA_ADD6
	   CALL PRINT_COMMAND                ;REPEAT - ADD MORE NUMBERS
	   CALL GET_YES
	   JE   ADD_DATA_JMP
	   CALL CALC_TIMES_PICKED          ;UPDATE TIMES A NUMBER WAS PICKED
           CALL WRITE_FILE                 ;THEN REWRITE FILE
           RET 
ADD_DATA_JMP:
	   JMP  ADD_DATA
ADD_DATA ENDP

PICK_WITHOUT PROC NEAR
	   MOV  AH, 9                       ;SCREEN BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   INT  21H
	   MOV  DX, OFFSET WITHOUT_MSG1            ;PRINT  MENU BAR
	   MOV  TEMP_MSG_ADDR, DX
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX       ;PRINT  BACKGROUND COLOR
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX       ;PRINT  FOREGROUND COLOR
	   CALL PRINT_HEADER
	   CALL READ_FILE                  ;READ FILE FOR TIMES PER COLUMN
	   MOV  TEMP_WORD, HIGHEST__NUMBER  ;AND TIMES PICKED INFO
	   MOV  AX, 65535
	   XOR  DX, DX
	   DIV  TEMP_WORD                   ;SETUP RANGE FOR RANDOM NUMBERS
	   MOV  DIVIDE_1, AX
PWO_START: MOV  CX, TIMES__PICKED
PWO_LOOP:  PUSH CX           
           CALL GET_RANDOM_NUMBER
	   CMP  AL, HIGHEST__NUMBER
	   JNA  PWO_CONT                    ;AND NOTHING LARGER
	   MOV  AL, HIGHEST__NUMBER
PWO_CONT:  INC  AX
	   MOV  CX, TIMES__PICKED           ;CHECK TO SEE IF NUMBER HAS ALREADY
PWO_LOOP1: MOV  SI,CX                       ;BEEN PICKED - IF SO GET NEW NUMBER
	   DEC  SI
	   CMP  TEMP_6+SI, AL
	   JNE  PWO_LOOP2
	   POP  CX
	   JMP  PWO_LOOP
PWO_LOOP2: LOOP PWO_LOOP1
	   POP  CX
	   MOV  SI, CX
	   DEC  SI
	   MOV  TEMP_6+SI, AL
           LOOP PWO_LOOP                   ;GOT ALL NUMBERS ?
           CALL LOW_HIGH_SEQUENCE          ;ARRANGE IN LOW/HIGH SEQUENCE
	   CALL PRINT_NUMBERS              ;THEN PRINT NUMBERS
	   CALL TIMES_PER_COLUMN
	   MOV  DX, OFFSET WANT_TO_CONTINUE        ;GET NEW GROUP OF NUMBERS
	   CALL PRINT_COMMAND
	   CALL GET_YES
	   JE   PWO_START
	   RET
PICK_WITHOUT ENDP

REVIEW PROC NEAR
	   MOV  AH, 9
	   MOV  DX, OFFSET CYAN_BACKGROUND         ;SETUP SCREEN COLORS FOR MENU BAR
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   MOV  DX, OFFSET REVIEW_MSG1             ;PRINT  MENU BAR
	   MOV  TEMP_MSG_ADDR, DX
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX
	   MOV  DX, OFFSET CYAN_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX       ;PRINT  FOREGROUND COLOR
	   CALL PRINT_HEADER
	   CALL READ_FILE
	   MOV  TEMP_LINE, 05               ;SETUP PRINT  POSITION
	   MOV  TEMP_COLUMN, 03
	   MOV  CX, 13
RV_LOOP:   PUSH CX
	   MOV  CX, 3
RV_LOOP5:  PUSH CX
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET REVIEW_MSG2             ;PRINT S FORMAT FOR NUMBERS
	   INT  21H
	   ADD  TEMP_COLUMN, 24
	   POP  CX
           LOOP RV_LOOP5
	   MOV  TEMP_COLUMN, 3
	   INC  TEMP_LINE
	   POP  CX
           LOOP RV_LOOP
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET REVIEW_MSG2
	   INT  21H
	   MOV  TEMP_LINE, 5                ;SET UP PRINT  POSITION FOR NUMBERS
	   MOV  TEMP_COLUMN, 4
	   MOV  CX, 13
	   MOV  TEMP_6_INDEX, 0
RV_LOOP1:  PUSH CX                         ;PRINT S 3 GROUPS OF 6 NUMBERS
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  TEMP_BYTE, 0        ;LOCATION ON LINE
	   MOV  CX, 6
RV_LOOP2:  PUSH CX
	   MOV  CX, 3
RV_LOOP4:  PUSH CX
	   MOV  SI, TEMP_6_INDEX
	   XOR  AH, AH
	   MOV  AL, [NUMBERS+SI]
	   CMP  AL, 0
	   JE   RV_LOOP6
	   CALL PRINT_NUMBER
RV_LOOP6:  ADD  TEMP_COLUMN, 4
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   INC  TEMP_6_INDEX
	   ADD  TEMP_BYTE, 5
	   POP  CX
           LOOP RV_LOOP4
	   POP  CX
           LOOP RV_LOOP2
	   MOV  TEMP_COLUMN, 4
	   ADD  TEMP_LINE, 1
	   POP  CX
           LOOP RV_LOOP1
RV_CONT:   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  TEMP_BYTE, 0        ;LOCATION ON LINE
	   MOV  CX, 6
RV_LOOP3:  PUSH CX
	   MOV  SI, TEMP_6_INDEX
	   XOR  AH, AH
	   MOV  AL, NUMBERS+SI
	   CMP  AL, 0
	   JE   RV_LOOP7
	   CALL PRINT_NUMBER
RV_LOOP7:  ADD  TEMP_COLUMN, 4
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   INC  TEMP_6_INDEX
	   ADD  TEMP_BYTE, 5
	   POP  CX
           LOOP RV_LOOP3
	   MOV  AH, 9
	   MOV  DX, RETURN_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET WANT_TO_CONTINUE
	   CALL PRINT_COMMAND
	   CALL GET_YES
	   RET
REVIEW ENDP

TIMES_PICKED PROC NEAR
	   MOV  AH, 9
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN          ;SCREEN BAACKGROUND COLOR
	   INT  21H
	   MOV  DX, OFFSET TIMES_PICKED_MSG1
	   MOV  TEMP_MSG_ADDR, DX
	   MOV  DX, 0
	   MOV  TEMP_MSG2_ADDR, DX
	   MOV  DX, OFFSET CYAN_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX   ;PRINT  FOREGROUND COLOR
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX   ;PRINT  BACKGROUND COLOR
	   CALL PRINT_HEADER
	   XOR  AH, AH
	   MOV  AL, HIGHEST__NUMBER
	   MOV  BL, 5
	   DIV  BL
           PUSH AX
	   XOR  AH, AH
	   MOV  TEMP_LOOP, AX
	   POP  AX
	   MOV  AL, AH
	   XOR  AH, AH
	   MOV  TEMP_LOOP2, AX
           CALL READ_FILE
	   MOV  TEMP_LINE, 3        ;SETUP SCREEN TO PRINT  NUMBERS
	   MOV  TEMP_COLUMN, 21
	   MOV  CX, TEMP_LOOP
TP_LOOP:   PUSH CX
	   MOV  CX, 5
TP_LOOP1:  PUSH CX
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET TIMES_PICKED_MSG2       ;"   /   "
	   INT  21H
	   ADD  TEMP_COLUMN, 8
	   POP  CX
           LOOP TP_LOOP1
	   MOV  TEMP_COLUMN, 21
	   ADD  TEMP_LINE, 2
	   POP  CX
           LOOP TP_LOOP
	   MOV  CX, TEMP_LOOP2           ;LAST LINE LOOP TO SET PRINT  NUMBERS
TP_LOOP5:  PUSH CX
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET TIMES_PICKED_MSG2       ;"   /   "
	   INT  21H
	   ADD  TEMP_COLUMN, 8
	   POP  CX
           LOOP TP_LOOP5
	   MOV  TEMP_LINE, 3         ;PRINT  NUMBERS LOOP
	   MOV  TEMP_COLUMN, 21
	   MOV  TEMP_LOCATION, 1     ;USED AS NUMBERS INDEX
	   MOV  TEMP_WORD, 0         ;USED AS TIMES INDES
	   MOV  CX, TEMP_LOOP
TP_LOOP3:  PUSH CX
	   MOV  CX, 5
TP_LOOP4:  PUSH CX
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   INC  DL
	   MOV  BH, 0
	   INT  10H
	   XOR  AH, AH
	   MOV  AL, TEMP_LOCATION
	   CALL PRINT_NUMBER
	   ADD  TEMP_COLUMN, 3
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   INC  DL
	   MOV  BH, 0
	   INT  10H
	   MOV  SI, TEMP_WORD
	   XOR  AH, AH
	   MOV  AL, FILE_TIMES_PICKED+SI
	   CALL PRINT_NUMBER
	   INC  TEMP_LOCATION
	   INC  TEMP_WORD
	   ADD  TEMP_COLUMN, 5
	   POP  CX
           LOOP TP_LOOP4
	   MOV  TEMP_COLUMN, 21
	   ADD  TEMP_LINE, 2
	   POP  CX
           LOOP TP_LOOP3
	   MOV  CX, TEMP_LOOP2    ;LAST LINE LOOP TO PRINT  NUMBERS
TP_LOOP6:  PUSH CX
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   INC  DL
	   MOV  BH, 0
	   INT  10H
	   XOR  AH, AH
	   MOV  AL, TEMP_LOCATION
	   CALL PRINT_NUMBER
	   ADD  TEMP_COLUMN, 3
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, TEMP_COLUMN
	   INC  DL
	   MOV  BH, 0
	   INT  10H
	   MOV  SI, TEMP_WORD
	   XOR  AH, AH
	   MOV  AL, FILE_TIMES_PICKED+SI
	   CALL PRINT_NUMBER
	   ADD  TEMP_COLUMN, 5
	   INC  TEMP_LOCATION
	   INC  TEMP_WORD
	   POP  CX
           LOOP TP_LOOP6
	   MOV  DX, OFFSET WANT_TO_CONTINUE
	   CALL PRINT_COMMAND
	   CALL GET_YES
	   RET
TIMES_PICKED ENDP

TIMES_PER_COLUMN PROC NEAR
	   MOV  AH, 2
	   MOV  DH, 19
	   MOV  DL, 26
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET TIMES_PER1     ;PRINT S - TIMES PER COLUMN
	   INT  21H
	   CALL READ_FILE
	   MOV  CX, TIMES__PICKED  ;SETUP LOOP  TO PRINT  - '   /   '
	   MOV  TEMP_COLUMN, 12
	   XOR  SI, SI
TPC_LOOP:  PUSH CX
	   MOV  AH, 2
	   MOV  DH, 21
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET TIMES_PER2        ;PRINT S - '   /   '
	   INT  21H
	   ADD  TEMP_COLUMN, 9
	   POP  CX
	   LOOP TPC_LOOP
	   XOR  AH, AH                     ;CALCULATE INNER LOOP INDEX
	   MOV  AL, FILE_NUMBERS_USED
	   MOV  BL, TIMES__PICKED
	   DIV  BL
	   MOV  TEMP_LINE, AL
	   CMP  AH, 0
	   JE   TPC_LOOP1
	   INC  TEMP_LINE           ;USED AS INNER LOOP INDEX
TPC_LOOP1: MOV  TEMP_COLUMN, 13     ;SETUP OUTER LOOP TO PRINT  NUMBERS
	   MOV  TEMP_WORD, 0
	   MOV  CX, TIMES__PICKED
TPC_LOOP2: PUSH CX
	   MOV  TEMP_6_INDEX, CX
	   MOV  AH, 2
	   MOV  DH, 21
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   MOV  SI, TEMP_WORD
	   XOR  AH, AH
	   MOV  AL, TEMP_6_L_H+SI
	   MOV  TEMP_LOCATION, AL     ;STORE PICKED NUMBER
	   CALL PRINT_NUMBER
	   ADD  TEMP_COLUMN, 4
	   MOV  TEMP_BYTE, 0
	   XOR  CH, CH
	   MOV  CL, TEMP_LINE        ;USED AS INNER LOOP INDEX
TPC_LOOP3: PUSH CX                  ;START INNER LOOP
	   MOV  AX, CX
	   MOV  BL, TIMES__PICKED
	   MUL  BL
	   MOV  BX, TEMP_6_INDEX
	   SUB  AX, BX
	   MOV  SI, AX
	   MOV  AL, NUMBERS+SI
	   CMP  AL, TEMP_LOCATION     ;COMPARE PICKED NUMBER WITH DATA BASE
	   JNE  TPC_LOOP4
	   INC  TEMP_BYTE
TPC_LOOP4: POP  CX
	   LOOP TPC_LOOP3
	   MOV  AH, 2
	   MOV  DH, 21
	   MOV  DL, TEMP_COLUMN
	   MOV  BH, 0
	   INT  10H
	   XOR  AH, AH
	   MOV  AL, TEMP_BYTE
	   ADD  TOTAL_PER_COLUMN, AL
	   CALL PRINT_NUMBER
	   ADD  TEMP_COLUMN, 5
	   INC  TEMP_WORD
	   POP  CX
	   LOOP TPC_LOOP2
	   MOV  AH, 2
	   MOV  DH, 17
	   MOV  DL, 28
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET TOTAL
	   INT  21H
	   MOV  AH, 2
	   MOV  DH, 17
	   MOV  DL, 37
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET TIMES_PER2
	   INT  21H
	   MOV  AH, 2
	   MOV  DH, 17
	   MOV  DL, 38
	   MOV  BH, 0
	   INT  10H
	   XOR  AH, AH
	   MOV  AL, TOTAL_TIMES_PICKED
	   CALL PRINT_NUMBER
	   MOV  AH, 2
	   MOV  DH, 17
	   MOV  DL, 41
	   MOV  BH, 0
	   INT  10H
	   XOR  AH, AH
	   MOV  AL, TOTAL_PER_COLUMN
	   CALL PRINT_NUMBER
	   RET
TIMES_PER_COLUMN ENDP

GET_NUMBERS PROC NEAR         ;GETS NUMBER AND STORES TWO DIGET
	   MOV  AH, 09         ;NUMBER IN VARIABLE IN_HEX
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET RED_FOREGROUND
	   INT  21H
	   MOV  CX, 4
	   MOV  SI, 00H
	   MOV  BX, OFFSET IN_NUMBERS
	   XOR  AL,AL
ZERO:      MOV  [BX+ SI], AL
	   INC  SI
	   Loop ZERO
	   MOV  IN_NUMBERS, 03H
	   MOV  AH, 0AH
	   MOV  DX, OFFSET IN_NUMBERS
	   INT  21H
	   MOV  IN_HEX, 00H
	   MOV  AL, NUMBERS_START
	   CMP  AL, 3AH
	   JNL  ZERO_INPUT
	   MOV  AL, NUMBERS_START
	   AND  AL, 0fH
	   MOV  BL, NUMBERS_START+1
	   CMP  BL, 0DH
	   JE   STORE_ONES
	   CMP  BL, 20H
	   JE   STORE_ONES
	   MOV  CX, 0AH
	   MUL  CX
	   MOV  IN_HEX, AL
ONES:      MOV  AL, NUMBERS_START+1
	   CMP  AL, 3AH
	   JNL  ZERO_INPUT
	   CMP  AL, 20H
	   JE   DONE_INPUT
	   MOV  AL, NUMBERS_START+1
	   AND  AL, 0fH
STORE_ONES:
	   ADD  IN_HEX, AL
DONE_INPUT:
	   MOV  AH, 9
	   MOV  DX, RETURN_FOREGROUND
	   INT  21H
	   MOV  DX, RETURN_BACKGROUND
	   INT  21H
	   RET
ZERO_inpuT:
	   MOV  IN_HEX, 255
	   RET
GET_NUMBERS ENDP

GET_YES PROC NEAR                     ;GET LETTER AND STORES IN IN_BUFFER
	   MOV  AH, 09
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET RED_FOREGROUND
	   INT  21H
	   MOV  DX, OFFSET GET_Y_N_MSG1       ;CHECK BUFFER_START
	   INT  21H
	   MOV  AH, 0AH
	   MOV  DX, OFFSET IN_BUFFER
	   MOV  IN_BUFFER, 02
	   INT  21H
	   MOV  AH, 9
	   MOV  DX, RETURN_FOREGROUND
	   INT  21H
	   MOV  DX, RETURN_BACKGROUND
	   INT  21H
	   CMP  BUFFER_START, "y"
	   JE   GYN_RETURN
	   CMP  BUFFER_START, "Y"
GYN_RETURN:
	   RET
GET_YES ENDP

PRINT_COMMAND PROC NEAR
	   PUSHA
	   MOV  TEMP_MSG_ADDR, DX
	   CALL FIND_CENTER
	   MOV  AH, 02
	   MOV  BH, 0
	   MOV  DH, 24
	   MOV  DL, 0
	   INT  10H
	   MOV  AH, 09
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET RED_FOREGROUND
	   INT  21H
	   MOV  DX, OFFSET ERASE_TO_END_OF_LINE
	   INT  21H
	   MOV  AH, 02
	   MOV  BH, 0
	   MOV  DX, TEMP_LENGTH
	   MOV  DH, 24
	   INT  10H
	   MOV  AH, 09
	   MOV  DX, TEMP_MSG_ADDR
	   INT  21H
	   MOV  DX, RETURN_FOREGROUND
	   INT  21H
	   MOV  DX, RETURN_BACKGROUND
	   INT  21H
	   POPA
	   RET
PRINT_COMMAND ENDP

PRINT_NUMBER PROC NEAR
	   PUSHA
	   PUSH AX                       ;TO ASCII AND PRINT S
	   MOV  DI, OFFSET ASCII_STRING
	   MOV  CX, 6
	   MOV  AL, "$"
	   REP  STOSB
	   POP  AX
	   MOV  SI, OFFSET ASCII_STRING
	   CMP  AX,0
	   JGE  POSITIVE
	   NEG  AX
	   MOV  BYTE PTR [SI],"-"
	   INC  SI
POSITIVE:  MOV  BX,10
	   MOV  CX,0
THELOOP:   MOV  DX,0
	   DIV  BX
	   PUSH DX
	   INC  CX
	   CMP  AX,0
	   JNE  THELOOP
POPLOOP:   POP  AX
	   ADD  AL,"0"
	   MOV  [SI],AL
	   INC  SI
	   LOOP POPLOOP
	   MOV  DX, OFFSET ASCII_STRING
	   MOV  AH, 09H
	   INT  21H
	   POPA
	   RET
PRINT_NUMBER ENDP

READ_FILE PROC NEAR
	   CMP  READ_FILE_FLAG, 0
	   JE   READ_CONTINUE
           RET 
READ_CONTINUE:
	   MOV  DX, OFFSET FILE_NAME
	   MOV  AX, 3D00H
	   INT  21H
	   JNC  GOOD_R_OPEN
	   PUSH AX
	   MOV  AH, 09H
	   MOV  DX, OFFSET NG_OPEN
	   INT  21H
	   POP  AX
	   CALL PRINT_NUMBER
	   CALL GET_YES
	   JMP  DONE
GOOD_R_OPEN:
	   MOV  BX, AX
	   MOV  FILE_HANDLE, AX
	   MOV  CX, FILE_LENGTH
	   MOV  DX, FILE
	   MOV  AH, 3FH
	   INT  21H
	   JNC  GOOD_READ
	   PUSH AX
	   MOV  AH, 09
	   MOV  DX, OFFSET NG_READ
	   INT  21H
	   POP  AX
	   CALL PRINT_NUMBER
	   CALL GET_YES
	   JMP  DONE
GOOD_READ: CMP  AX, FILE_LENGTH
	   JE   READ_RET
	   MOV  AH, 09
	   MOV  DX, OFFSET NG_READ2
	   INT  21H
	   CALL PRINT_NUMBER
	   CALL GET_YES
	   JMP  DONE
READ_RET:  MOV  BX, FILE_HANDLE
	   MOV  AH, 3EH
	   INT  21H
	   MOV  READ_FILE_FLAG, 1
           RET
READ_FILE ENDP

WRITE_FILE PROC NEAR
	   MOV  DX, OFFSET FILE_NAME
	   MOV  AX, 3C01H
	   INT  21H
	   JNC  GOOD_W_OPEN
	   PUSH AX
	   MOV  AH, 09H
	   MOV  DX, OFFSET NG_OPEN
	   INT  21H
	   POP  AX
	   CALL PRINT_NUMBER
	   CALL GET_YES
	   JMP  DONE
GOOD_W_OPEN: 
	   MOV  BX, AX
	   MOV  FILE_HANDLE, AX
	   MOV  CX, FILE_LENGTH
	   MOV  DX, FILE
	   MOV  AH, 40H
	   INT  21H
	   JNC  GOOD_WRITE
	   PUSH AX
	   MOV  AH, 09
	   MOV  DX, OFFSET NG_WRITE
	   INT  21H
	   POP  AX
	   CALL PRINT_NUMBER
	   CALL GET_YES
	   JMP  DONE
GOOD_WRITE:
	   CMP  AX, FILE_LENGTH
	   JE   CLOSE_FILE
	   MOV  AH, 09
	   MOV  DX, OFFSET NG_WRITE2
	   INT  21H
           CALL GET_YES              
CLOSE_FILE:
	   MOV  BX, FILE_HANDLE
	   MOV  AH, 3EH
	   INT  21H
           RET
WRITE_FILE ENDP

MOVE_BLOCK PROC NEAR
	   MOV  CX, (TOTAL__NUMBERS-TIMES__PICKED) + 1
	   MOV  SI, OFFSET (FILE_LENGTH - 1) - TIMES__PICKED
	   MOV  DI, OFFSET FILE_LENGTH - 1
           STD
	   SHR  CX, 1
	   JNC  WORD_MOVE
	   MOVSB
WORD_MOVE: DEC  SI
	   DEC  DI
	   REP MOVSW
	   RET
MOVE_BLOCK ENDP

PRINT_NUMBERS PROC NEAR
	   XOR  AL, AL
	   MOV  TOTAL_PER_COLUMN, AL
	   MOV  TOTAL_TIMES_PICKED, AL
	   MOV  TEMP_LOCATION, 5     ;SETUP LOOP
	   MOV  TEMP_BYTE, 0
	   MOV  CX, TIMES__PICKED
	   MOV  TEMP_WORD, 0
P_N_LOOP1: PUSH CX
	   MOV  AH, 02
	   MOV  DH, TEMP_LOCATION
	   MOV  DL, 14
	   MOV  BH, 0
	   INT  10H
	   MOV  AH,9
	   MOV  DX, RETURN_FOREGROUND
	   INT  21H
	   MOV  DX, OFFSET ADD_WITH2            ;PRINTS - THIS IS YOUR    NUMBER
	   INT  21H
	   MOV  AH, 2
	   MOV  DH, TEMP_LOCATION
	   MOV  DL, 28
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  SI, TEMP_WORD
	   MOV  DX, CHOICE+[SI]      ;PRINT S CHOICE EG. FIRST SECOND
	   INT  21H
	   MOV  AH, 2
	   MOV  DH, TEMP_LOCATION
	   MOV  DL, 42
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, RETURN_FOREGROUND
	   INT  21H
	   MOV  AL, TEMP_BYTE
	   XOR  AH, AH
	   MOV  SI, AX
	   MOV  AL, TEMP_6_L_H+SI   ;PRINT S - NUMBER  CHG
	   CALL PRINT_NUMBER
	   MOV  AH, 2
	   MOV  DH, TEMP_LOCATION
	   MOV  DL, 52
	   MOV  BH, 0
	   INT  10H
	   MOV  AL, TEMP_BYTE
	   XOR  AH, AH
	   MOV  SI, AX
	   MOV  AL, TEMP_6_L_H+SI
	   MOV  SI, AX
	   DEC  SI
	   MOV  AL, FILE_TIMES_PICKED+SI
	   ADD  TOTAL_TIMES_PICKED, AL
	   CALL PRINT_NUMBER           ;PRINTS TIMES PICKED
	   MOV  AH, 9
	   MOV  DX, RETURN_FOREGROUND
	   INT  21H
	   ADD  TEMP_WORD, 2
	   ADD  TEMP_LOCATION, 2
	   INC  TEMP_BYTE
	   POP  CX
	   LOOP JMP_PN_LOOP
	   MOV  DX, RETURN_BACKGROUND
	   INT  21H
           RET
JMP_PN_LOOP:
	   JMP  P_N_LOOP1
PRINT_NUMBERS ENDP

LOW_HIGH_SEQUENCE PROC NEAR
	   PUSHA
	   MOV  CX, TIMES__PICKED
	   XOR  AH, AH
	   MOV  TEMP_WORD, 0
L_H_SEQ1:  
           PUSH CX
	   MOV  SI, TEMP_WORD      ;MOV E FROM LOW TO HIGH
	   MOV  AL, TEMP_6+SI
	   MOV  CX, TIMES__PICKED  ;FIND LOWEST NUMBER OF THE TEMP_6
L_H_SEQ2: 
	   MOV  SI, CX
	   DEC  SI
	   CMP  AL, TEMP_6+SI
	   JB   HIGHER
	   MOV  TEMP_LENGTH, SI    ;SAVE LOWEST POSITION
	   MOV  AL,TEMP_6+SI
HIGHER:    LOOP L_H_SEQ2
	   MOV  SI, TEMP_WORD
	   MOV  TEMP_6_L_H+SI, AL   ;SAVE LOWEST NUMBER
	   MOV  SI, TEMP_LENGTH     ;REPLACE LOWEST NUMBER WITH 255
	   MOV  TEMP_6+SI, 255
	   INC  TEMP_WORD
	   POP  CX
	   LOOP L_H_SEQ1
	   POPA
	   RET
LOW_HIGH_SEQUENCE ENDP

CALC_TIMES_PICKED PROC NEAR
	   MOV  AL, 0
	   MOV  DI, OFFSET FILE_TIMES_PICKED
	   MOV  CX, HIGHEST__NUMBER
	   REP  STOSB
	   MOV  CX, TOTAL__NUMBERS
	   XOR  AH, AH
	   MOV  FILE_NUMBERS_USED, AH
CALC_TIMES_LOOP:
	   MOV  SI, CX
	   DEC  SI
	   MOV  AL, NUMBERS+SI
	   CMP  AL, 0
	   JE   CALC_ZERO_LOOP
	   MOV  SI, AX
	   DEC  SI
	   INC  FILE_TIMES_PICKED+SI
	   INC  FILE_NUMBERS_USED
CALC_ZERO_LOOP:
           LOOP CALC_TIMES_LOOP 
           RET
CALC_TIMES_PICKED ENDP

GET_RANDOM_NUMBER PROC NEAR
	   XOR  AH, AH
	   IN   AL, 42H          ; GETS RANDOM NUMBER FROM TIMER AND
	   MOV  TEMP_BYTE, AL   ; DETERMINS THE RANGE BY DIV IDING
	   IN   AL, 42H          ; THE NUMBER BY DIV IDE_1 THEN
	   XOR  AH, AH          ; RETURNS WITH THE NUMBER IN AX
	   MUL  TEMP_BYTE
	   MOV  TEMP_WORD, AX
	   XOR  AH, AH
	   IN   AL, 42H
	   MUL  TEMP_WORD
	   XOR  DX, DX
	   DIV  DIVIDE_1
	   RET
GET_RANDOM_NUMBER ENDP

CALC_DIVISOR PROC NEAR
	   MOV  DX, OFFSET WEEKS_TO_USE
	   CALL PRINT_COMMAND
CALC_LOOP: CALL GET_NUMBERS
	   CMP  IN_HEX, 20
	   JBE  CALC_CONT
	   MOV  DX, OFFSET CALC_ERROR
	   CALL PRINT_COMMAND
	   JMP  CALC_LOOP
CALC_CONT: MOV  DX, 0
	   SHL  IN_HEX, 1
	   XOR  AH, AH
	   MOV  AL, FILE_NUMBERS_USED
	   MOV  BL, TIMES__PICKED
	   DIV  BL
	   MOV  WEEKS, AL
	   MOV  AL, IN_HEX
	   CMP  AL, WEEKS
	   JB   CD_LOOP
	   MOV  AL, WEEKS
CD_LOOP:   MOV  WEEKS, AL
	   XOR  DX, DX
	   XOR  AH, AH
	   MOV  TEMP_BYTE, (HIGHEST__NUMBER + TIMES__PICKED)
	   MUL  TEMP_BYTE
	   MOV  TEMP_WORD, AX
	   MOV  AX, 65535
	   XOR  DX, DX
	   DIV  TEMP_WORD
	   MOV  DIVIDE_1, AX
	   RET
CALC_DIVISOR ENDP
START      ENDP


PRINT_HEADER PROC NEAR
	   MOV  AH, 09H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   INT  21H
	   MOV  DX, OFFSET RED_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   INT  21H
	   MOV  DX, OFFSET ERASE_TO_END_OF_LINE
	   INT  21H
	   CALL FIND_CENTER
	   MOV  AH, 2
	   MOV  DX, TEMP_LENGTH
	   MOV  DH, 0
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, TEMP_MSG_ADDR
	   INT  21H
	   MOV  AX, 0
	   CMP  TEMP_MSG2_ADDR, AX
	   JE   FC_RETURN
	   MOV  AX, TEMP_MSG2_ADDR
	   MOV  TEMP_MSG_ADDR, AX
	   MOV  AH, 02H
	   MOV  DH, 1
	   MOV  DL, 0
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET ERASE_TO_END_OF_LINE
	   INT  21H
	   CALL FIND_CENTER
	   MOV  AH, 2
	   MOV  DX, TEMP_LENGTH
	   MOV  DH, 1
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, TEMP_MSG_ADDR
	   INT  21H
FC_RETURN: MOV  AH, 9
	   MOV  DX, RETURN_FOREGROUND
	   INT  21H
	   MOV  DX, RETURN_BACKGROUND
	   INT  21H
	   RET
PRINT_HEADER  ENDP

FIND_CENTER PROC NEAR
	   PUSHA                 ;FINDS HALF LENGTH OF TEMP_MSG_ADDR
	   MOV  TEMP_LENGTH, 79   ;AND STORES RESULTS IN TEMP_LENGTH
	   MOV  SI, 00H
	   MOV  BX, TEMP_MSG_ADDR
LENGTH_LOOP:
	   MOV  AL,[BX]+SI
	   INC  SI
	   CMP  AL, "$"
	   JNE  LENGTH_LOOP
	   DEC  SI
	   SUB  TEMP_LENGTH, SI
	   SAR  TEMP_LENGTH, 1
	   POPA
	   RET
FIND_CENTER ENDP

GET_TEMP_6 PROC NEAR
ADD_DATA_LOOP:
	   MOV  SI, 0
	   MOV  CX, 06
	   MOV  TEMP_LINE, 5                ;INITIAL SCREEN LOCATION
	   MOV  TEMP_6_INDEX, 0
A_DATA_LOOP:
	   PUSH CX
	   PUSH SI
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, 24
	   MOV  BH, 0
	   INT  10H
	   MOV  AH,09
	   MOV  DX, OFFSET GREEN_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET BLUE_FOREGROUND
	   INT  21H
	   MOV  DX, OFFSET DATA_ADD3               ;PRINT S - THIS IS YOUR       NUMBER
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, 38
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   POP  SI
	   PUSH SI
	   MOV  DX, CHOICE+[SI]             ;PRINT S -CHOICE EG FIRST, SECOND
	   INT  21H
	   MOV  DX, OFFSET DATA_ADD2               ;PRINT S - ENTER NUMBERS IN LOW/HIGH
	   CALL PRINT_COMMAND
GET_IN_NUMBER:
	   CALL GET_NUMBERS                ;GETS NUMBER AND CHECKS RANGE
	   MOV  AH, 0
	   MOV  AL, IN_HEX
	   CMP  AX, 0                       ;TO CORRECT DATA
	   JE   ADD_DATA_LOOP_J
	   CMP  AX, 255                     ;TO RETURN TO MAIN MENU
	   JE   AD_RET                       ;WITHOUT WRITING TO DATA BASE
	   CMP  AX, HIGHEST__NUMBER
	   JBE  GOOD_NUMBER
NG_NUMBER: CALL TOO_LARGE                  ;IF OUT OF RANGE PRINT  MSG THEN
	   JMP  GET_IN_NUMBER               ;GET NEW NUMBER
AD_RET:    POP  SI
	   POP  CX
	   JMP  PRT_MAIN_SCREEN
ADD_DATA_LOOP_J:
	   POP  SI
	   POP  CX
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, 0
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9                    ;********
	   MOV  DX, OFFSET CYAN_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET ERASE_TO_END_OF_LINE
	   INT  21H                      ;*************
	   JMP  ADD_DATA_LOOP
GOOD_NUMBER:
	   MOV  SI, TEMP_6_INDEX            ;TAKES GOOD NUMBERS AND STORES
	   INC  TEMP_6_INDEX                ;THEM IN TEMP_6
	   MOV  TEMP_6+SI, AL
	   ADD  TEMP_COLUMN, 30
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, 24
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   INT  21H
	   MOV  DX, OFFSET CYAN_FOREGROUND
	   INT  21H
	   MOV  DX, OFFSET DATA_ADD3               ;PRINT S - THIS IS YOUR       NUMBER
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, 38
	   MOV  BH, 0
	   INT  10H
	   MOV  AH, 9
	   POP  SI
	   MOV  DX, CHOICE+[SI]             ;PRINT S -CHOICE EG FIRST, SECOND
	   INT  21H
	   MOV  AH, 02H
	   MOV  DH, TEMP_LINE
	   MOV  DL, 52
	   MOV  BH, 0
	   INT  10H
	   XOR  AH, AH
	   MOV  AL, IN_HEX
	   CALL PRINT_NUMBER
	   ADD  TEMP_LINE, 2
	   ADD  SI, 2
	   MOV  TEMP_COLUMN, 24             ;RESET START OF LINE LOCATION
	   POP  CX
	   LOOP A_DATA_LOOP_J
	   RET
A_DATA_LOOP_J:
	   JMP  A_DATA_LOOP
TOO_LARGE: MOV  DX, OFFSET DATA_ADD5
	   CALL PRINT_COMMAND
	   RET
GET_TEMP_6 ENDP

TIMES_PER PROC NEAR
TIMES_PER_START:
	   MOV  AH, 9
	   MOV  DX, OFFSET CYAN_BACKGROUND       ;SCREEN BACKGROUND COLOR
	   INT  21H
	   MOV  DX, OFFSET CLEAR_SCREEN
	   INT  21H
	   MOV  DX, OFFSET BLUE_BACKGROUND
	   MOV  RETURN_BACKGROUND, DX     ;PRINT  BACKGROUND COLOR
	   MOV  DX, OFFSET GREEN_FOREGROUND
	   MOV  RETURN_FOREGROUND, DX     ;PRINT  FOREGROUND COLOR
	   MOV  DX, OFFSET TIMES_PER_MSG1
	   MOV  TEMP_MSG_ADDR, DX
	   MOV  DX, 0
	   MOV  TEMP_MSG2_ADDR, DX
	   CALL PRINT_HEADER
	   CALL READ_FILE
	   CALL GET_TEMP_6
	   CALL LOW_HIGH_SEQUENCE
	   CALL PRINT_NUMBERS
	   CALL TIMES_PER_COLUMN
	   MOV  DX, OFFSET WANT_TO_CONTINUE
	   CALL PRINT_COMMAND
	   CALL GET_YES
	   JE   TIMES_PER_START
	   RET
TIMES_PER ENDP

	   END START
